<!DOCTYPE html>
<html>

<head>
  <title>react-native-webrtc server</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>

<body>
  <div id="textRoom" style="display: none;">
    <div id="textRoomContent">
      <h3>Text Room</h3>
    </div>
    <input id="textRoomInput">
    <button onclick="textRoomPress();">Send</button>
  </div>
  <video id="selfView" autoplay></video>
  <div id="remoteViewContainer"></div>
  <div id="roomIDContainer">
    <input id="roomID" value="abc">
    <button onclick="press();">Join/Create room</button>
  </div>
</body>
<script src="/socket.io/socket.io.js"></script>
<script type="text/javascript">

  var socket = io.connect();
  var RTCPeerConnection = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection || window.msRTCPeerConnection;
  var RTCSessionDescription = window.RTCSessionDescription || window.mozRTCSessionDescription || window.webkitRTCSessionDescription || window.msRTCSessionDescription;
  navigator.getUserMedia = navigator.getUserMedia || navigator.mozGetUserMedia || navigator.webkitGetUserMedia || navigator.msGetUserMedia;
  var twilioIceServers = [
    { url: 'stun:global.stun.twilio.com:3478?transport=udp' }
    // { url: 'turn:global.turn.twilio.com:3478?transport=udp',
    //   username: 'ea757ad2c42b932c7f2abe480295e7eb039dc2b13b78c86bc412818ed51e5eea',
    //   credential: 'MPnnojPRoPDI+B3kLONGF9P440Lb8NkrTq+FxxJBVro=' },
    // { url: 'turn:global.turn.twilio.com:3478?transport=tcp',
    //   username: 'ea757ad2c42b932c7f2abe480295e7eb039dc2b13b78c86bc412818ed51e5eea',
    //   credential: 'MPnnojPRoPDI+B3kLONGF9P440Lb8NkrTq+FxxJBVro=' },
    // { url: 'turn:global.turn.twilio.com:443?transport=tcp',
    //   username: 'ea757ad2c42b932c7f2abe480295e7eb039dc2b13b78c86bc412818ed51e5eea',
    //   credential: 'MPnnojPRoPDI+B3kLONGF9P440Lb8NkrTq+FxxJBVro=' } 
  ];
  var configuration = { "iceServers": [{ "url": "stun:stun.l.google.com:19302" }] };
  // configuration.iceServers = twilioIceServers;
  var pcPeers = {};
  var selfView = document.getElementById("selfView");
  var remoteViewContainer = document.getElementById("remoteViewContainer");
  var localStream;

  function getLocalStream() {
    navigator.getUserMedia({ "audio": true, "video": true }, function (stream) {
      localStream = stream;
      selfView.src = URL.createObjectURL(stream);
      selfView.muted = true;
    }, logError);
  }
  function join(roomID) {
    socket.emit('join', roomID, function (socketIds) {
      //console.log('join', socketIds);
      for (var i in socketIds) {
        var socketId = socketIds[i];
        createPC(socketId, true);
      }
    });
  }
  function createPC(socketId, isOffer) {
    var pc = new RTCPeerConnection(configuration);
    pcPeers[socketId] = pc;
    pc.onicecandidate = function (event) {
      //console.log('onicecandidate', event);
      if (event.candidate) {
        socket.emit('exchange', { 'to': socketId, 'candidate': event.candidate });
      }
    };
    function createOffer() {
      pc.createOffer(function (desc) {
        //console.log('createOffer', desc);
        pc.setLocalDescription(desc, function () {
          //console.log('setLocalDescription', pc.localDescription);
          socket.emit('exchange', { 'to': socketId, 'sdp': pc.localDescription });
        }, logError);
      }, logError);
    }
    pc.onnegotiationneeded = function () {
      //console.log('onnegotiationneeded');
      if (isOffer) {
        createOffer();
      }
    }
    pc.oniceconnectionstatechange = function (event) {
      //console.log('oniceconnectionstatechange', event);
      if (event.target.iceConnectionState === 'connected') {
        createDataChannel();
      }
    };
    pc.onsignalingstatechange = function (event) {
      //console.log('onsignalingstatechange', event);
    };
    pc.onaddstream = function (event) {
      //console.log('onaddstream', event);
      var element = document.createElement('video');
      element.id = "remoteView" + socketId;
      element.autoplay = 'autoplay';
      element.src = URL.createObjectURL(event.stream);
      remoteViewContainer.appendChild(element);
    };
    pc.addStream(localStream);
    function createDataChannel() {
      if (pc.textDataChannel) {
        return;
      }
      var dataChannel = pc.createDataChannel("text");
      dataChannel.onerror = function (error) {
        //console.log("dataChannel.onerror", error);
      };
      dataChannel.onmessage = function (event) {
        //console.log("dataChannel.onmessage:", event.data);
        var content = document.getElementById('textRoomContent');
        content.innerHTML = content.innerHTML + '<p>' + socketId + ': ' + event.data + '</p>';
      };
      dataChannel.onopen = function () {
        //console.log('dataChannel.onopen');
        var textRoom = document.getElementById('textRoom');
        textRoom.style.display = "block";
      };
      dataChannel.onclose = function () {
        //console.log("dataChannel.onclose");
      };
      pc.textDataChannel = dataChannel;
    }
    return pc;
  }
  function exchange(data) {
    var fromId = data.from;
    var pc;
    if (fromId in pcPeers) {
      pc = pcPeers[fromId];
    } else {
      pc = createPC(fromId, false);
    }
    if (data.sdp) {
      //console.log('exchange sdp', data);
      pc.setRemoteDescription(new RTCSessionDescription(data.sdp), function () {
        if (pc.remoteDescription.type == "offer")
          pc.createAnswer(function (desc) {
            //console.log('createAnswer', desc);
            pc.setLocalDescription(desc, function () {
              //console.log('setLocalDescription', pc.localDescription);
              socket.emit('exchange', { 'to': fromId, 'sdp': pc.localDescription });
            }, logError);
          }, logError);
      }, logError);
    } else {
      //console.log('exchange candidate', data);
      candidate = new RTCIceCandidate(data.candidate);
      pc.addIceCandidate(candidate);
    }
  }
  function leave(socketId) {
    //console.log('leave', socketId);
    var pc = pcPeers[socketId];
    pc.close();
    delete pcPeers[socketId];
    var video = document.getElementById("remoteView" + socketId);
    if (video) video.remove();
  }
  socket.on('exchange', function (data) {
    exchange(data);
  });
  socket.on('leave', function (socketId) {
    leave(socketId);
  });
  socket.on('connect', function (data) {
    //console.log('connect');
    getLocalStream();
  });
  socket.on('disconnect', function (data) {
    console.log('disconnect');
    // socket.socket.reconnect();
  });
  socket.on('error', function(){
    console('error')
    socket.socket.reconnect();
  });
  
  function logError(error) {
    //console.log("logError", error);
  }
  function press() {
    var roomID = document.getElementById('roomID').value;
    if (roomID == "") {
      alert('Please enter room ID');
    } else {
      var roomIDContainer = document.getElementById('roomIDContainer');
      roomIDContainer.parentElement.removeChild(roomIDContainer);
      join(roomID);
    }
  }
  function textRoomPress() {
    var text = document.getElementById('textRoomInput').value;
    if (text == "") {
      alert('Enter something');
    } else {
      document.getElementById('textRoomInput').value = '';
      var content = document.getElementById('textRoomContent');
      content.innerHTML = content.innerHTML + '<p>' + 'Me' + ': ' + text + '</p>';
      for (var key in pcPeers) {
        var pc = pcPeers[key];
        pc.textDataChannel.send(text);
      }
    }
  }
  function updateIndicator(event) {
      console.log(event.type)
      if(event.type === "online"){
        join('abc')
      }
    // Show a different icon based on offline/online
  }
  window.addEventListener('online',  updateIndicator);
  window.addEventListener('offline', updateIndicator);
</script>
<script>
  (function (i, s, o, g, r, a, m) {
  i['GoogleAnalyticsObject'] = r; i[r] = i[r] || function () {
    (i[r].q = i[r].q || []).push(arguments)
  }, i[r].l = 1 * new Date(); a = s.createElement(o),
    m = s.getElementsByTagName(o)[0]; a.async = 1; a.src = g; m.parentNode.insertBefore(a, m)
  })(window, document, 'script', '//www.google-analytics.com/analytics.js', 'ga');
  ga('create', 'UA-68314333-1', 'auto');
  ga('send', 'pageview');
</script>

</html>